package edu.brynmawr.twobutton;

import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import java.util.Random;

public class FragmentOneButtonIM extends Fragment implements View.OnClickListener{

    private LinearLayout mainLayout;

    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState ) {
        // set up the initial layout
        mainLayout = new LinearLayout(getContext());
        mainLayout.setId(View.generateViewId());
        mainLayout.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        mainLayout.setBackgroundColor(Color.WHITE);
        mainLayout.setOrientation(LinearLayout.VERTICAL);
        return mainLayout;
    }

    /**
     * Generate a random color
     * @return the random color
     */
    private int randomColor() {
        Random r = new Random();
        return Color.rgb(r.nextInt(255), r.nextInt(255), r.nextInt(255));
    }

    public void onViewCreated(@NonNull View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        layoutDoButton();
    }


    private void layoutDoButton() {
        mainLayout.removeAllViews();
        {
            TextView tv = new TextView(getContext());
            tv.setText("public class FragmentOneButtonIM extends Fragment implements View.OnClickListener\n\n" +
                    "    public void onClick(View v) {\n" +
                    "        v.setBackgroundColor(randomColor());\n" +
                    "    }\n");
            mainLayout.addView(tv, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
        }

        {
            Button b = new Button(getContext());
            b.setText("Push me");
            b.setBackgroundColor(Color.GREEN);
            mainLayout.addView(b, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 1));
            b.setOnClickListener(this);
        }
        mainLayout.addView(new View(getContext()), new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
    }

    @Override
    public void onClick(View v) {
        v.setBackgroundColor(randomColor());
    }
}
