package edu.brynmawr.twobutton;

import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import java.util.Random;

public class FragmentTwoButton extends Fragment {

    private LinearLayout mainLayout;

    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState ) {
        // set up the initial layout
        mainLayout = new LinearLayout(getContext());
        mainLayout.setId(View.generateViewId());
        mainLayout.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        mainLayout.setBackgroundColor(Color.WHITE);
        mainLayout.setOrientation(LinearLayout.VERTICAL);
        return mainLayout;
    }

    /**
     * Generate a random color
     * @return the random color
     */
    private int randomColor() {
        Random r = new Random();
        return Color.rgb(r.nextInt(255), r.nextInt(255), r.nextInt(255));
    }

    public void onViewCreated(@NonNull View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        layoutDoButton();
    }


    String pval="AAA";
    int ival=0;
    private void layoutDoButton() {
        mainLayout.removeAllViews();
        final TextView tv1 = new TextView(getContext());
        mainLayout.addView(tv1, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
        {
            Button b = new Button(getContext());
            b.setText("Push me");
            b.setBackgroundColor(Color.GREEN);
            mainLayout.addView(b, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 1));
            b.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    Handler handler = new Handler(Looper.getMainLooper());
                    handler.postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            tv1.setText(pval.substring(pval.length()>1?pval.length()-2:0)+(ival++));
                        }
                    }, 2000);
                    Handler handler2 = new Handler();
                    handler2.postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            tv1.setText(pval.substring(pval.length()>0?pval.length()-1:0));
                        }
                    }, 3000);
                }
            });
        }
        mainLayout.addView(new View(getContext()), new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
        {
            Button b = new Button(getContext());
            b.setText("Push me 2");
            b.setBackgroundColor(Color.GREEN);
            mainLayout.addView(b, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 1));
            b.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    mainLayout.setBackgroundColor(randomColor());
                    tv1.setText("BBB");
                    pval=null;
                }
            });
        }
        mainLayout.addView(new View(getContext()), new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
    }

}
