package edu.brynmawr.twobutton;

import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import java.util.Random;

public class FragmentTwoButtonIM extends Fragment implements View.OnClickListener{

    private LinearLayout mainLayout;

    private static final int FIRST_BUTTON = 14567;
    private static final int SECOND_BUTTON = 14568;


    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState ) {
        // set up the initial layout
        mainLayout = new LinearLayout(getContext());
        mainLayout.setId(View.generateViewId());
        mainLayout.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        mainLayout.setBackgroundColor(Color.WHITE);
        mainLayout.setOrientation(LinearLayout.VERTICAL);
        return mainLayout;
    }

    /**
     * Generate a random color
     * @return the random color
     */
    private int randomColor() {
        Random r = new Random();
        return Color.rgb(r.nextInt(255), r.nextInt(255), r.nextInt(255));
    }

    public void onViewCreated(@NonNull View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        layoutDoButton();
    }


    private void layoutDoButton() {
        float density = getContext().getResources().getDisplayMetrics().density;
        mainLayout.removeAllViews();
        mainLayout.addView(new View(getContext()), new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
        {
            Button b = new Button(getContext());
            b.setText("Push me");
            b.setId(FIRST_BUTTON);
            b.setBackgroundColor(Color.GREEN);
            mainLayout.addView(b, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, (int)(42*density), 1));
            b.setOnClickListener(this);
        }
        mainLayout.addView(new View(getContext()), new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
        {
            Button b = new Button(getContext());
            b.setText("Push me");
            b.setId(SECOND_BUTTON);
            b.setBackgroundColor(Color.GREEN);
            mainLayout.addView(b, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, (int)(42*density), 0));
            b.setOnClickListener(this);
        }
        mainLayout.addView(new View(getContext()), new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 0, 5));
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case FIRST_BUTTON:
                v.setBackgroundColor(randomColor());
                break;
            case SECOND_BUTTON:
                mainLayout.setBackgroundColor(randomColor());
                break;
            default:
                Log.i("THISS", "Unknown item clicked on " + v.getId());
                break;
        }
    }
}
