package edu.brynmawr.twobutton;

import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {

    public static final int MAT_1B     = 17305;
    public static final int MAT_1B_IM  = 17306;
    public static final int MAT_2B     = 17307;
    public static final int MAT_2B_IM  = 17308;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.i("THISS", "OnCreate Mainact");
        setContentView(R.layout.activity_main);

        FragmentManager fragmentManager = this.getSupportFragmentManager();
        FragmentTransaction transaction = fragmentManager.beginTransaction();
        transaction.replace(R.id.mainlayout, new FragmentWelcome(), null);
        transaction.addToBackStack(null);
        transaction.commit();
        int tt = fragmentManager.getBackStackEntryCount();
        for(int i = 0; i < tt; ++i) {
            fragmentManager.popBackStack();
        }

        Intent intent = getIntent();
        String action = intent.getAction();

        Log.i("THISS", intent + " " + action);


    }

    public boolean onCreateOptionsMenu(Menu menu){
        Log.i("THISS", "Filling options");
        {
            MenuItem edit_item = menu.add(0, MAT_1B, 1, "1B");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
        }
        {
            MenuItem edit_item = menu.add(0, MAT_1B_IM, 1, "1B IM");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
        }
        {
            MenuItem edit_item = menu.add(0, MAT_2B, 1, "2B");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
        }
        {
            MenuItem edit_item = menu.add(0, MAT_2B_IM, 1, "2B IM");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
        }
         return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        Log.i("THISS", "Clicked on menu item " + id);

        if (id == MAT_1B) {
            FragmentManager fragmentManager = this.getSupportFragmentManager();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(R.id.mainlayout, new FragmentOneButton(), null);
            transaction.addToBackStack(null);
            transaction.commit();
            return true;
        }
        if (id == MAT_1B_IM) {
            FragmentManager fragmentManager = this.getSupportFragmentManager();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(R.id.mainlayout, new FragmentOneButtonIM(), null);
            transaction.addToBackStack(null);
            transaction.commit();
            return true;
        }
        if (id == MAT_2B) {
            FragmentManager fragmentManager = this.getSupportFragmentManager();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(R.id.mainlayout, new FragmentTwoButton(), null);
            transaction.addToBackStack(null);
            transaction.commit();
            return true;
        }
        if (id == MAT_2B_IM) {
            FragmentManager fragmentManager = this.getSupportFragmentManager();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(R.id.mainlayout, new FragmentTwoButtonIM(), null);
            transaction.addToBackStack(null);
            transaction.commit();
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    public void onBackPressed() {
        FragmentManager fragmentManager = this.getSupportFragmentManager();
        int tt = fragmentManager.getBackStackEntryCount();
        Log.i("THISs", "Back stack " + tt);
        if (tt>1)
            super.onBackPressed();
    }
}